/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.PangkatDao;
import com.portofolio.dto.PangkatDto;
import com.portofolio.entity.Pangkat;
import com.portofolio.entity.vo.PangkatId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class PangkatService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private PangkatDao pangkatDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(PangkatDto pangkatDto) {
		result.clear();
		PangkatId id = new PangkatId();
		Integer kdPangkat =getIdTerahir(Pangkat.class.getSimpleName());
		id.setKdPangkat(kdPangkat);
		id.setKdProfile(getKdProfile());
		Pangkat pangkat = CommonUtil.findOne(pangkatDao, id);
		if (CommonUtil.isNullOrEmpty(pangkat)) {
			pangkat = new Pangkat();
			BeanUtils.copyProperties(pangkatDto, pangkat);
			pangkat.setNoRec(generateUuid32());
			pangkat.setVersion(1);
			pangkat.setId(id);
			pangkat = pangkatDao.save(pangkat);
			result.put("pangkat", pangkat);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("pangkat.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(PangkatDto pangkatDto, Integer kdPangkat, Integer version) {
		result.clear();
		PangkatId id = new PangkatId();
		id.setKdPangkat(kdPangkat);
		id.setKdProfile(getKdProfile());
		Pangkat pangkat = CommonUtil.findOne(pangkatDao, id);
		if (CommonUtil.isNotNullOrEmpty(pangkat)) {
			if (version < pangkat.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(pangkatDto, pangkat);
			pangkat.setVersion(version);
			pangkat = pangkatDao.save(pangkat);
			result.put("pangkat", pangkat);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaPangkat,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaPangkat)) {
			pageRes = pangkatDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = pangkatDao.findAllList(getKdProfile(), namaPangkat, statusEnabled, pageReq);
		}
		result.put("pangkat", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdPangkat(Integer kdPangkat) {
		result.clear();
		result.put("pangkat", pangkatDao.findByKdPangkat(getKdProfile(), kdPangkat, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdPangkat, Integer version) {
		result.clear();
		PangkatId id = new PangkatId();
		id.setKdPangkat(kdPangkat);
		id.setKdProfile(getKdProfile());
		Pangkat pangkat = CommonUtil.findOne(pangkatDao, id);
		if (CommonUtil.isNotNullOrEmpty(pangkat)) {
			if (version < pangkat.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			pangkat.setStatusEnabled(false);
			pangkat.setVersion(version);
			pangkat = pangkatDao.save(pangkat);
			result.put("pangkat", pangkat);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
